package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class CwGlSettleExample {

	protected String orderByClause;
	protected boolean distinct;
	protected List<Criteria> oredCriteria;

	public CwGlSettleExample() {
		oredCriteria = new ArrayList<Criteria>();
	}

	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	public String getOrderByClause() {
		return orderByClause;
	}

	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	public boolean isDistinct() {
		return distinct;
	}

	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
	}

	protected abstract static class GeneratedCriteria {
		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<Criterion>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		protected void addCriterionForJDBCDate(String condition, Date value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Date(value.getTime()), property);
		}

		protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
			if (values == null || values.size() == 0) {
				throw new RuntimeException("Value list for " + property + " cannot be null or empty");
			}
			List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
			Iterator<Date> iter = values.iterator();
			while (iter.hasNext()) {
				dateList.add(new java.sql.Date(iter.next().getTime()));
			}
			addCriterion(condition, dateList, property);
		}

		protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
		}

		public Criteria andPkSettleIsNull() {
			addCriterion("PK_SETTLE is null");
			return (Criteria) this;
		}

		public Criteria andPkSettleIsNotNull() {
			addCriterion("PK_SETTLE is not null");
			return (Criteria) this;
		}

		public Criteria andPkSettleEqualTo(String value) {
			addCriterion("PK_SETTLE =", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleNotEqualTo(String value) {
			addCriterion("PK_SETTLE <>", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleGreaterThan(String value) {
			addCriterion("PK_SETTLE >", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleGreaterThanOrEqualTo(String value) {
			addCriterion("PK_SETTLE >=", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleLessThan(String value) {
			addCriterion("PK_SETTLE <", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleLessThanOrEqualTo(String value) {
			addCriterion("PK_SETTLE <=", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleLike(String value) {
			addCriterion("PK_SETTLE like", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleNotLike(String value) {
			addCriterion("PK_SETTLE not like", value, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleIn(List<String> values) {
			addCriterion("PK_SETTLE in", values, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleNotIn(List<String> values) {
			addCriterion("PK_SETTLE not in", values, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleBetween(String value1, String value2) {
			addCriterion("PK_SETTLE between", value1, value2, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkSettleNotBetween(String value1, String value2) {
			addCriterion("PK_SETTLE not between", value1, value2, "pkSettle");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookIsNull() {
			addCriterion("PK_GLORGBOOK is null");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookIsNotNull() {
			addCriterion("PK_GLORGBOOK is not null");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookEqualTo(String value) {
			addCriterion("PK_GLORGBOOK =", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookNotEqualTo(String value) {
			addCriterion("PK_GLORGBOOK <>", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookGreaterThan(String value) {
			addCriterion("PK_GLORGBOOK >", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookGreaterThanOrEqualTo(String value) {
			addCriterion("PK_GLORGBOOK >=", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookLessThan(String value) {
			addCriterion("PK_GLORGBOOK <", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookLessThanOrEqualTo(String value) {
			addCriterion("PK_GLORGBOOK <=", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookLike(String value) {
			addCriterion("PK_GLORGBOOK like", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookNotLike(String value) {
			addCriterion("PK_GLORGBOOK not like", value, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookIn(List<String> values) {
			addCriterion("PK_GLORGBOOK in", values, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookNotIn(List<String> values) {
			addCriterion("PK_GLORGBOOK not in", values, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookBetween(String value1, String value2) {
			addCriterion("PK_GLORGBOOK between", value1, value2, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPkGlorgbookNotBetween(String value1, String value2) {
			addCriterion("PK_GLORGBOOK not between", value1, value2, "pkGlorgbook");
			return (Criteria) this;
		}

		public Criteria andPeriodIsNull() {
			addCriterion("PERIOD is null");
			return (Criteria) this;
		}

		public Criteria andPeriodIsNotNull() {
			addCriterion("PERIOD is not null");
			return (Criteria) this;
		}

		public Criteria andPeriodEqualTo(String value) {
			addCriterion("PERIOD =", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodNotEqualTo(String value) {
			addCriterion("PERIOD <>", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodGreaterThan(String value) {
			addCriterion("PERIOD >", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodGreaterThanOrEqualTo(String value) {
			addCriterion("PERIOD >=", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodLessThan(String value) {
			addCriterion("PERIOD <", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodLessThanOrEqualTo(String value) {
			addCriterion("PERIOD <=", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodLike(String value) {
			addCriterion("PERIOD like", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodNotLike(String value) {
			addCriterion("PERIOD not like", value, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodIn(List<String> values) {
			addCriterion("PERIOD in", values, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodNotIn(List<String> values) {
			addCriterion("PERIOD not in", values, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodBetween(String value1, String value2) {
			addCriterion("PERIOD between", value1, value2, "period");
			return (Criteria) this;
		}

		public Criteria andPeriodNotBetween(String value1, String value2) {
			addCriterion("PERIOD not between", value1, value2, "period");
			return (Criteria) this;
		}

		public Criteria andIssettleIsNull() {
			addCriterion("ISSETTLE is null");
			return (Criteria) this;
		}

		public Criteria andIssettleIsNotNull() {
			addCriterion("ISSETTLE is not null");
			return (Criteria) this;
		}

		public Criteria andIssettleEqualTo(String value) {
			addCriterion("ISSETTLE =", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleNotEqualTo(String value) {
			addCriterion("ISSETTLE <>", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleGreaterThan(String value) {
			addCriterion("ISSETTLE >", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleGreaterThanOrEqualTo(String value) {
			addCriterion("ISSETTLE >=", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleLessThan(String value) {
			addCriterion("ISSETTLE <", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleLessThanOrEqualTo(String value) {
			addCriterion("ISSETTLE <=", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleLike(String value) {
			addCriterion("ISSETTLE like", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleNotLike(String value) {
			addCriterion("ISSETTLE not like", value, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleIn(List<String> values) {
			addCriterion("ISSETTLE in", values, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleNotIn(List<String> values) {
			addCriterion("ISSETTLE not in", values, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleBetween(String value1, String value2) {
			addCriterion("ISSETTLE between", value1, value2, "issettle");
			return (Criteria) this;
		}

		public Criteria andIssettleNotBetween(String value1, String value2) {
			addCriterion("ISSETTLE not between", value1, value2, "issettle");
			return (Criteria) this;
		}

		public Criteria andSettleUserIsNull() {
			addCriterion("SETTLE_USER is null");
			return (Criteria) this;
		}

		public Criteria andSettleUserIsNotNull() {
			addCriterion("SETTLE_USER is not null");
			return (Criteria) this;
		}

		public Criteria andSettleUserEqualTo(String value) {
			addCriterion("SETTLE_USER =", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserNotEqualTo(String value) {
			addCriterion("SETTLE_USER <>", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserGreaterThan(String value) {
			addCriterion("SETTLE_USER >", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserGreaterThanOrEqualTo(String value) {
			addCriterion("SETTLE_USER >=", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserLessThan(String value) {
			addCriterion("SETTLE_USER <", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserLessThanOrEqualTo(String value) {
			addCriterion("SETTLE_USER <=", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserLike(String value) {
			addCriterion("SETTLE_USER like", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserNotLike(String value) {
			addCriterion("SETTLE_USER not like", value, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserIn(List<String> values) {
			addCriterion("SETTLE_USER in", values, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserNotIn(List<String> values) {
			addCriterion("SETTLE_USER not in", values, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserBetween(String value1, String value2) {
			addCriterion("SETTLE_USER between", value1, value2, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleUserNotBetween(String value1, String value2) {
			addCriterion("SETTLE_USER not between", value1, value2, "settleUser");
			return (Criteria) this;
		}

		public Criteria andSettleTimeIsNull() {
			addCriterion("SETTLE_TIME is null");
			return (Criteria) this;
		}

		public Criteria andSettleTimeIsNotNull() {
			addCriterion("SETTLE_TIME is not null");
			return (Criteria) this;
		}

		public Criteria andSettleTimeEqualTo(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME =", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeNotEqualTo(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME <>", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeGreaterThan(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME >", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeGreaterThanOrEqualTo(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME >=", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeLessThan(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME <", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeLessThanOrEqualTo(Date value) {
			addCriterionForJDBCDate("SETTLE_TIME <=", value, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeIn(List<Date> values) {
			addCriterionForJDBCDate("SETTLE_TIME in", values, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeNotIn(List<Date> values) {
			addCriterionForJDBCDate("SETTLE_TIME not in", values, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeBetween(Date value1, Date value2) {
			addCriterionForJDBCDate("SETTLE_TIME between", value1, value2, "settleTime");
			return (Criteria) this;
		}

		public Criteria andSettleTimeNotBetween(Date value1, Date value2) {
			addCriterionForJDBCDate("SETTLE_TIME not between", value1, value2, "settleTime");
			return (Criteria) this;
		}

		public Criteria andUseStateIsNull() {
			addCriterion("USE_STATE is null");
			return (Criteria) this;
		}

		public Criteria andUseStateIsNotNull() {
			addCriterion("USE_STATE is not null");
			return (Criteria) this;
		}

		public Criteria andUseStateEqualTo(String value) {
			addCriterion("USE_STATE =", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotEqualTo(String value) {
			addCriterion("USE_STATE <>", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateGreaterThan(String value) {
			addCriterion("USE_STATE >", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateGreaterThanOrEqualTo(String value) {
			addCriterion("USE_STATE >=", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLessThan(String value) {
			addCriterion("USE_STATE <", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLessThanOrEqualTo(String value) {
			addCriterion("USE_STATE <=", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLike(String value) {
			addCriterion("USE_STATE like", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotLike(String value) {
			addCriterion("USE_STATE not like", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateIn(List<String> values) {
			addCriterion("USE_STATE in", values, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotIn(List<String> values) {
			addCriterion("USE_STATE not in", values, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateBetween(String value1, String value2) {
			addCriterion("USE_STATE between", value1, value2, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotBetween(String value1, String value2) {
			addCriterion("USE_STATE not between", value1, value2, "useState");
			return (Criteria) this;
		}

		public Criteria andCreateUserIsNull() {
			addCriterion("CREATE_USER is null");
			return (Criteria) this;
		}

		public Criteria andCreateUserIsNotNull() {
			addCriterion("CREATE_USER is not null");
			return (Criteria) this;
		}

		public Criteria andCreateUserEqualTo(String value) {
			addCriterion("CREATE_USER =", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotEqualTo(String value) {
			addCriterion("CREATE_USER <>", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserGreaterThan(String value) {
			addCriterion("CREATE_USER >", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
			addCriterion("CREATE_USER >=", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLessThan(String value) {
			addCriterion("CREATE_USER <", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLessThanOrEqualTo(String value) {
			addCriterion("CREATE_USER <=", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLike(String value) {
			addCriterion("CREATE_USER like", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotLike(String value) {
			addCriterion("CREATE_USER not like", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserIn(List<String> values) {
			addCriterion("CREATE_USER in", values, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotIn(List<String> values) {
			addCriterion("CREATE_USER not in", values, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserBetween(String value1, String value2) {
			addCriterion("CREATE_USER between", value1, value2, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotBetween(String value1, String value2) {
			addCriterion("CREATE_USER not between", value1, value2, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIsNull() {
			addCriterion("CREATE_TIME is null");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIsNotNull() {
			addCriterion("CREATE_TIME is not null");
			return (Criteria) this;
		}

		public Criteria andCreateTimeEqualTo(Date value) {
			addCriterion("CREATE_TIME =", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotEqualTo(Date value) {
			addCriterion("CREATE_TIME <>", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeGreaterThan(Date value) {
			addCriterion("CREATE_TIME >", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
			addCriterion("CREATE_TIME >=", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeLessThan(Date value) {
			addCriterion("CREATE_TIME <", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
			addCriterion("CREATE_TIME <=", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIn(List<Date> values) {
			addCriterion("CREATE_TIME in", values, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotIn(List<Date> values) {
			addCriterion("CREATE_TIME not in", values, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeBetween(Date value1, Date value2) {
			addCriterion("CREATE_TIME between", value1, value2, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
			addCriterion("CREATE_TIME not between", value1, value2, "createTime");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIsNull() {
			addCriterion("UPDATE_USER is null");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIsNotNull() {
			addCriterion("UPDATE_USER is not null");
			return (Criteria) this;
		}

		public Criteria andUpdateUserEqualTo(String value) {
			addCriterion("UPDATE_USER =", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotEqualTo(String value) {
			addCriterion("UPDATE_USER <>", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserGreaterThan(String value) {
			addCriterion("UPDATE_USER >", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
			addCriterion("UPDATE_USER >=", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLessThan(String value) {
			addCriterion("UPDATE_USER <", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLessThanOrEqualTo(String value) {
			addCriterion("UPDATE_USER <=", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLike(String value) {
			addCriterion("UPDATE_USER like", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotLike(String value) {
			addCriterion("UPDATE_USER not like", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIn(List<String> values) {
			addCriterion("UPDATE_USER in", values, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotIn(List<String> values) {
			addCriterion("UPDATE_USER not in", values, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserBetween(String value1, String value2) {
			addCriterion("UPDATE_USER between", value1, value2, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotBetween(String value1, String value2) {
			addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNull() {
			addCriterion("UPDATE_TIME is null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNotNull() {
			addCriterion("UPDATE_TIME is not null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeEqualTo(Date value) {
			addCriterion("UPDATE_TIME =", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotEqualTo(Date value) {
			addCriterion("UPDATE_TIME <>", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThan(Date value) {
			addCriterion("UPDATE_TIME >", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
			addCriterion("UPDATE_TIME >=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThan(Date value) {
			addCriterion("UPDATE_TIME <", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
			addCriterion("UPDATE_TIME <=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIn(List<Date> values) {
			addCriterion("UPDATE_TIME in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotIn(List<Date> values) {
			addCriterion("UPDATE_TIME not in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeBetween(Date value1, Date value2) {
			addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
			addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
			return (Criteria) this;
		}

		public Criteria andRemarkIsNull() {
			addCriterion("REMARK is null");
			return (Criteria) this;
		}

		public Criteria andRemarkIsNotNull() {
			addCriterion("REMARK is not null");
			return (Criteria) this;
		}

		public Criteria andRemarkEqualTo(String value) {
			addCriterion("REMARK =", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotEqualTo(String value) {
			addCriterion("REMARK <>", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkGreaterThan(String value) {
			addCriterion("REMARK >", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkGreaterThanOrEqualTo(String value) {
			addCriterion("REMARK >=", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLessThan(String value) {
			addCriterion("REMARK <", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLessThanOrEqualTo(String value) {
			addCriterion("REMARK <=", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLike(String value) {
			addCriterion("REMARK like", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotLike(String value) {
			addCriterion("REMARK not like", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkIn(List<String> values) {
			addCriterion("REMARK in", values, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotIn(List<String> values) {
			addCriterion("REMARK not in", values, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkBetween(String value1, String value2) {
			addCriterion("REMARK between", value1, value2, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotBetween(String value1, String value2) {
			addCriterion("REMARK not between", value1, value2, "remark");
			return (Criteria) this;
		}
	}

	public static class Criteria extends GeneratedCriteria {
		protected Criteria() {
			super();
		}
	}

	public static class Criterion {
		private String condition;
		private Object value;
		private Object secondValue;
		private boolean noValue;
		private boolean singleValue;
		private boolean betweenValue;
		private boolean listValue;
		private String typeHandler;

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}
	}
  
}